(* portlandViewController.ml     Wrapper for Portland view controller
 *
 * Copyright (c) 2016 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)

external _delegate : nativeint -> PortlandViewControllerD.t =
    "PortlandViewController_delegate"
external _setDelegate_ : nativeint -> PortlandViewControllerD.t -> unit =
    "PortlandViewController_setDelegate_"

class t robjcv =
object (self)
    inherit Wrapper.t robjcv

    method delegate = _delegate self#contents
    method setDelegate' d = _setDelegate_ self#contents d
end

let _ =
    let wrap robjcv = new t robjcv in
    Callback.register "PortlandViewController.wrap" wrap
