(* ui.mli     Some base types from UIKit
 *
 * Copyright (c) 2016 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)

(* (For simplicity, these view controller types are specialized for
 * Portland.)
 *)

class type
    portlandViewControllerD =
        object
        inherit Wrappee.t
        method label : UiLabel.t
        method setLabel' : UiLabel.t -> unit
        method activate : unit
        method deactivate : unit
        method viewController'viewWillAppear' :
            portlandViewController -> bool -> unit
        method viewController'viewWillDisappear' :
            portlandViewController -> bool -> unit
        method viewControllerShouldAutorotate' :
            portlandViewController -> bool
        method timerTick' : NsTimer.t -> unit
        end

and
    portlandViewController =
        object
        inherit Wrapper.t
        method delegate : portlandViewControllerD
        method setDelegate' : portlandViewControllerD -> unit
        end

class type
    window =
        object
        inherit Wrapper.t
        method frame : float * float * float * float
        method rootViewController : portlandViewController
        end

class type
    application =
        object
        inherit Wrapper.t
        method delegate : applicationDelegate
        end

and 
    applicationDelegate =
        object
        inherit Wrappee.t
        method window : window
        method setWindow' : window -> unit
        method applicationDidFinishLaunching' : application -> unit
        method applicationWillResignActive' : application -> unit
        method applicationDidBecomeActive' : application -> unit
        end
